chrome.runtime.onInstalled.addListener(() => {
  chrome.storage.sync.set({ latest: {
    prompt: 'Haven\'t searched anything yet',
    generatedText: ''
  }})

  chrome.storage.sync.set({ history: [] })
})

// Code to handle the right-click menu options
chrome.contextMenus.create({
  id: "prompt1",
  title: "Send to OpenAI prompt1",
  contexts:["selection"],
});

chrome.contextMenus.create({
  id: "prompt2",
  title: "Send to OpenAI prompt2",
  contexts:["selection"],
});

chrome.contextMenus.create({
  id: "prompt3",
  title: "Send to OpenAI prompt3",
  contexts:["selection"],
});

// Handle the click event for the right-click menu options
chrome.contextMenus.onClicked.addListener(function(info, tab) {
  if (info.menuItemId === "prompt1") {
    sendTextToOpenAI("please write me an article on the following topic: " + info.selectionText);
  } else if (info.menuItemId === "prompt2") {
    sendTextToOpenAI("please write me a headline on the following topic: " + info.selectionText);
  } else if (info.menuItemId === "prompt3") {
    sendTextToOpenAI("please write me an email on the following topic: " + info.selectionText);
  }
});

// Function to send the text to OpenAI
function sendTextToOpenAI(text) {
  chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
    chrome.tabs.sendMessage(tabs[0].id, {type: "openai_request", text: text});
  });
}
