// Code to handle the message from the background script
chrome.runtime.onMessage.addListener(async (request, sender, sendResponse) => {
    if (request.type === "openai_request") {
        const response = await fetch("https://api.openai.com/v1/completions", {
            method: "POST",
            headers: {
            "Content-Type": "application/json",
            "Authorization": "Bearer XXXXX",
            },
            body: JSON.stringify({
            model: "text-davinci-003",
            prompt: request.text,
            temperature: 0,
            max_tokens: 100,
            }),
        });

        const responseData = await response.json();
        const generatedText = responseData.choices[0].text;
        
        chrome.runtime.sendMessage({ type: "openai_response", prompt: request.text, generatedText: generatedText });
        chrome.storage.sync.set({ latest: {
            prompt: request.text,
            generatedText: generatedText
        }})

        chrome.storage.sync.get(['history'], (result) => {
          const data = result.history;
            chrome.storage.sync.set({ history: [{
                prompt: request.text,
                generatedText: generatedText
            }, ...data]});
        })
    }
});