chrome.runtime.onInstalled.addListener(() => {
  chrome.storage.sync.set({ latest: {
    prompt: 'Haven\'t searched anything yet',
    generatedText: ''
  }})

  chrome.storage.sync.set({ 
    prompt1: {
      label: 'Write an article',
      prompt1_value: 'please write me an article on the following topic:'
    }, 
    prompt2: {
      label: 'Write headline',
      prompt2_value: 'please write me a headline on the following topic:'
    },
    prompt3: {
      label: 'Write me an email',
      prompt3_value: 'please write me an email on the following topic:'
    }
  })

  chrome.storage.sync.set({ history: [] })
})

let prompt1 = "please write me an article on the following topic: "
let prompt2 = "please write me a headline on the following topic: "
let prompt3 = "please write me an email on the following topic: "

// Code to handle the right-click menu options
chrome.contextMenus.create({
  id: "prompt1",
  title: "Write an article",
  contexts:["selection"],
});

chrome.contextMenus.create({
  id: "prompt2",
  title: "Write headline",
  contexts:["selection"],
});

chrome.contextMenus.create({
  id: "prompt3",
  title: "Write me an email",
  contexts:["selection"],
});

// Handle the click event for the right-click menu options
chrome.contextMenus.onClicked.addListener(function(info, tab) {
  console.table({ prompt1, prompt2, prompt3 });
  if (info.menuItemId === "prompt1") {
    sendTextToOpenAI(prompt1 + info.selectionText);
  } else if (info.menuItemId === "prompt2") {
    sendTextToOpenAI(prompt2 + info.selectionText);
  } else if (info.menuItemId === "prompt3") {
    sendTextToOpenAI(prompt3 + info.selectionText);
  }
});

// Function to send the text to OpenAI
function sendTextToOpenAI(text) {
  chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
    chrome.tabs.sendMessage(tabs[0].id, {type: "openai_request", text: text});
  });
}


function updateContext() {
  chrome.storage.sync.get(['prompt1','prompt2','prompt3'], (result) => {
    Object.keys(result).forEach(el => {
      chrome.contextMenus.update(el,{
          title: result[el].label
      },() => {
        if(el === 'prompt1') {
          prompt1 = result[el][Object.keys(result[el])[1]]
        } else if (el === 'prompt2') {
          prompt2 = result[el][Object.keys(result[el])[1]]
        } else if (el === 'prompt3') {
          prompt3 = result[el][Object.keys(result[el])[1]]
        }
      })
    })
  })
}

chrome.runtime.onMessage.addListener((req, sender, sendResponse) => {
  // 2. A page requested user data, respond with a copy of `user`
  if (req.type === 'updateContext') {
    updateContext();
  }
});
