document.addEventListener('DOMContentLoaded', function() {
  // Your code here
  document.getElementById("response").innerHTML = 'Hello World From other sizd'
  chrome.storage.sync.get(['latest'], (req) => {
    const latest_response = req.latest;
    document.getElementById("response").innerHTML = `
        <p><strong>Query</strong>: ${latest_response.prompt}</p> 
        <br>
        <div><strong>Answer</strong>: ${latest_response.generatedText}</div>
      `
  })

  chrome.storage.sync.get(['history'], (req) => {
    const history = req.history;
    history.forEach((item) => {
      document.getElementById("history").innerHTML = `<div id="history_item">
        <p><strong>Query</strong>: ${item.prompt}</p> 
        <br>
        <div><strong>Answer</strong>: ${item.generatedText}</div></div> <br> <br>
      ` + document.getElementById("history").innerHTML;
    })
  })
});

chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
  if (request.type === "openai_response") {
    chrome.storage.sync.set({ latest: {
      prompt: request.prompt,
      generatedText: request.generatedText
    }}).then(() => {
      document.getElementById("response").innerHTML = `
        <p><strong>Query</strong>: ${request.prompt}</p> 
        <br>
        <div><strong>Answer</strong>: ${request.generatedText}</div>
      `
    })
  }
});


function convertToCSV() {
  chrome.storage.sync.get(['history'], (req) => {
    const history = req.history;
    let csvContent = "data:text/csv;charset=utf-8," 
    + "Query, Answer," + '\n';

    history.forEach((e) => {
      csvContent += e.prompt.replaceAll('\n', '').replaceAll(',', '') + ','
      + e.generatedText.replaceAll('\n', '').replaceAll(',', '') + ',' + '\n'
    })

    console.log(csvContent)

    console.table(history)

    var encodedUri = encodeURI(csvContent);
    window.open(encodedUri);
  })
}

/** Download Funcitonality */
document.getElementById("download_csv").addEventListener('click', () => {
  console.log('Download CSV')
  convertToCSV()
})

/** Download Funcitonality */
document.getElementById("clear_history").addEventListener('click', () => {
  console.log('Clear History')
  chrome.storage.sync.set({ history: [] })
})
console.log(document.querySelectorAll('.nav'))
document.querySelectorAll('.nav').forEach(i => {
  i.addEventListener('click', () => {
    document.querySelectorAll('.nav').forEach((curr) => curr.classList.remove('nav_btn'))
    i.classList.add('nav_btn')
    const id_related = i.getAttribute('related');
    console.log(document.getElementById(id_related))
    document.querySelectorAll('.connected').forEach(curr_el => curr_el.classList.remove('hide_el'))
    document.querySelectorAll('.connected').forEach(curr_el => {
      if(curr_el.getAttribute('id') !== id_related) {
        curr_el.classList.add('hide_el');
      }
    })
  })
})

chrome.storage.sync.get(['prompt1','prompt2','prompt3'], (result) => {
  Object.keys(result).forEach(el => {
    document.getElementById(el).value = result[el].label;
    // Just don't ask me how I wrote this 💢
    document.getElementById(Object.keys(result[el])[1]).value = result[el][Object.keys(result[el])[1]]
  })
})

document.getElementById('save_settings').addEventListener('click', () => {
  const label1 = document.getElementById('prompt1').value;
  const prompt1_value = document.getElementById('prompt1_value').value;
  const label2 = document.getElementById('prompt2').value;
  const prompt2_value = document.getElementById('prompt2_value').value;
  const label3 = document.getElementById('prompt3').value;
  const prompt3_value = document.getElementById('prompt3_value').value;

  chrome.storage.sync.set({
    prompt1: {
      label: label1,
      prompt1_value
    }, 
    prompt2: {
      label: label2,
      prompt2_value
    },
    prompt3: {
      label: label3,
      prompt3_value
    }
  })

  chrome.runtime.sendMessage({ type: "updateContext" });
})


